peg::parser! {
    grammar mul() for str {
        rule number() -> u32
            = n:$(['0'..='9']+) {? n.parse().or(Err("u32")) }

        rule mul_fn() -> u32
            = "mul(" a:number() "," b:number() ")" { a * b }

        rule step() -> u32
            = n:mul_fn() { n }
            / [_] { 0 }

        pub rule program() -> u32
            = x:step()+ { x.iter().sum() }
    }
}

pub fn parse(a: &str) -> u32 {
    mul::program(a).unwrap()
}
